﻿//=============================================================================
// nazo_TP_PHAandTCR.js
//=============================================================================

/*:
 * @plugindesc TP回復アイテムにも『薬の知識』と『TPチャージ率』を適用するプラグイン
 *
 * @author なぞのいきもの
 *
 * @help
 * このプラグインには、プラグインコマンドはありません。
 * 
 * TP増加の効果を持つアイテムに、使用者の『薬の知識』と
 * 対象者の『TPチャージ率』の補正が有効になります。
 * 小数点以下は切り捨てられます。
 * 
 * パラメータを導入する技術はありませんでした。
 * 片方の補正を無効にしたい場合は、このjsファイルをメモ帳などで開き
 * 該当する行を各自コメントアウトしてください。
 *
 */

(function() {

Game_Action.prototype.itemEffectGainTp = function(target, effect) {
    var value = Math.floor(effect.value1);
    if (this.isItem()) {
        value *= this.subject().pha;	// 薬の知識を適用しない場合はこの行をコメントアウト
	value *= target.tcr;		// TPチャージ率を適用しない場合はこの行をコメントアウト
	value = Math.floor(value);
    }
    if (value !== 0) {
        target.gainTp(value);
        this.makeSuccess(target);
    }
};

})();